//==========================================================================
// ####ECOSGPLCOPYRIGHTBEGIN####                                            
// -------------------------------------------                              
// This file is part of eCos, the Embedded Configurable Operating System.   
//
// eCos is free software; you can redistribute it and/or modify it under    
// the terms of the GNU General Public License as published by the Free     
// Software Foundation; either version 2 or (at your option) any later      
// version.                                                                 
//
// eCos is distributed in the hope that it will be useful, but WITHOUT      
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or    
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License    
// for more details.                                                        
//
// You should have received a copy of the GNU General Public License        
// along with eCos; if not, write to the Free Software Foundation, Inc.,    
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.            
//
// As a special exception, if other files instantiate templates or use      
// macros or inline functions from this file, or you compile this file      
// and link it with other works to produce a work based on this file,       
// this file does not by itself cause the resulting work to be covered by   
// the GNU General Public License. However the source code for this file    
// must still be made available in accordance with section (3) of the GNU   
// General Public License v2.                                               
//
// This exception does not invalidate any other reasons why a work based    
// on this file might be covered by the GNU General Public License.         
// -------------------------------------------                              
// ####ECOSGPLCOPYRIGHTEND####                                              
//==========================================================================

/**
 ****************************************************************************
 * Driver for Cirrus Logic CS42XX stereo audio codec.
 *
 * @file   cs42xx_testaudio.h
 * @brief  Tests applicable on CS42XX driver - Audio part.
 *
 * @author David Tylski
 * @date   Mar. 2007
 *
 * Copyright (C) 2007, Parrot S.A. - www.parrot.biz
 ****************************************************************************
 */
#ifndef _CS42XX_TEST_AUDIO_H_
#define _CS42XX_TEST_AUDIO_H_

#include <cyg/io/aai.h>



/*
 * Defines.
 ***********/


// Advanced Audio Interface.

/** AAI output device. */
#define CS42XX_TEST_AAIDEVICE_OUT		"/dev/aai/hp"
/** AAI input device. */
#define CS42XX_TEST_AAIDEVICE_IN		"/dev/aai/mic12"



/*
 * Exported functions.
 **********************/


// Select the audio test to be run.
extern void
CS42XX_TestAudio_Run(CS42XX_TEST_ID testid);

// Configure audio part of CS42XX driver testing software.
extern cyg_bool
CS42XX_TestAudio_Init(void);



#endif // _CS42XX_TEST_AUDIO_H_
