//==========================================================================
//
//      io/serial/arm/arm_arm9_p5dev_ser.inl
//
//      P5DEV Serial I/O definitions
//
//==========================================================================
//
// Author(s):    ivan.djelic@parrot.fr
// Date:         2005-11-17
// Purpose:      P5dev Serial I/O module
// Description:
//
//==========================================================================

#include <cyg/hal/hal_intr.h>
#include <cyg/hal/p5dev.h>

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P5DEV_SERIAL0

static parrot5_serial_info p5dev_serial_info0 = {
  PARROT5_UART0, SYS_CEN_UART0CLK, CYGNUM_HAL_INTERRUPT_UART0,
};

#if CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL0_BUFSIZE > 0
static unsigned char
p5dev_serial_out_buf0[CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL0_BUFSIZE];
static unsigned char
p5dev_serial_in_buf0[CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL0_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p5dev_channel_serial0,
				 parrot5_serial_funs,
				 p5dev_serial_info0,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL0_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p5dev_serial_out_buf0[0],
				 sizeof(p5dev_serial_out_buf0),
				 &p5dev_serial_in_buf0[0],
				 sizeof(p5dev_serial_in_buf0));
#else
static SERIAL_CHANNEL( p5dev_channel_serial0,
		       parrot5_serial_funs,
		       p5dev_serial_info0,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL0_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p5dev_serial_io0,
             CYGDAT_IO_SERIAL_ARM_P5DEV_SERIAL0_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p5dev_channel_serial0 );
#endif //  CYGPKG_IO_SERIAL_ARM_P5DEV_SERIAL0

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P5DEV_SERIAL1

static parrot5_serial_info p5dev_serial_info1 = {
  PARROT5_UART1, SYS_CEN_UART1CLK, CYGNUM_HAL_INTERRUPT_UART1,
};

#if CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL1_BUFSIZE > 0
static unsigned char
p5dev_serial_out_buf1[CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL1_BUFSIZE];
static unsigned char
p5dev_serial_in_buf1[CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL1_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p5dev_channel_serial1,
				 parrot5_serial_funs,
				 p5dev_serial_info1,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL1_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p5dev_serial_out_buf1[0],
				 sizeof(p5dev_serial_out_buf1),
				 &p5dev_serial_in_buf1[0],
				 sizeof(p5dev_serial_in_buf1));
#else
static SERIAL_CHANNEL( p5dev_channel_serial1,
		       parrot5_serial_funs,
		       p5dev_serial_info1,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL1_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p5dev_serial_io1,
             CYGDAT_IO_SERIAL_ARM_P5DEV_SERIAL1_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p5dev_channel_serial1 );
#endif //  CYGPKG_IO_SERIAL_ARM_P5DEV_SERIAL1

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P5DEV_SERIAL2

static parrot5_serial_info p5dev_serial_info2 = {
  PARROT5_UART2, SYS_CEN_UART2CLK, CYGNUM_HAL_INTERRUPT_UART2,
};

#if CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL2_BUFSIZE > 0
static unsigned char
p5dev_serial_out_buf2[CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL2_BUFSIZE];
static unsigned char
p5dev_serial_in_buf2[CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL2_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p5dev_channel_serial2,
				 parrot5_serial_funs,
				 p5dev_serial_info2,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL2_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p5dev_serial_out_buf2[0],
				 sizeof(p5dev_serial_out_buf2),
				 &p5dev_serial_in_buf2[0],
				 sizeof(p5dev_serial_in_buf2));
#else
static SERIAL_CHANNEL( p5dev_channel_serial2,
		       parrot5_serial_funs,
		       p5dev_serial_info2,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P5DEV_SERIAL2_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p5dev_serial_io2,
             CYGDAT_IO_SERIAL_ARM_P5DEV_SERIAL2_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p5dev_channel_serial2 );
#endif //  CYGPKG_IO_SERIAL_ARM_P5DEV_SERIAL2

//-----------------------------------------------------------------------------
// EOF arm_arm9_p5dev_ser.inl
