//==========================================================================
//
//      io/serial/cortexa/cortexa_p7_ser.inl
//
//      Parrot 7 Serial I/O definitions
//
//==========================================================================
//
// Author(s):    ivan.djelic@parrot.com
// Date:         2011-08-03
// Purpose:      Parrot 7 Serial I/O module
// Description:
//
//==========================================================================

#include <cyg/hal/hal_intr.h>
#include <cyg/hal/p7.h>

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL0

static parrot5_serial_info p7dev_serial_info0 = {
    P7_UART_BASE(0),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_0,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL0_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf0[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL0_BUFSIZE];
static unsigned char
p7dev_serial_in_buf0[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL0_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial0,
				 parrot5_serial_funs,
				 p7dev_serial_info0,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL0_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf0[0],
				 sizeof(p7dev_serial_out_buf0),
				 &p7dev_serial_in_buf0[0],
				 sizeof(p7dev_serial_in_buf0));
#else
static SERIAL_CHANNEL(p7dev_channel_serial0,
		       parrot5_serial_funs,
		       p7dev_serial_info0,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL0_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io0,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL0_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial0 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL0

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL1

static parrot5_serial_info p7dev_serial_info1 = {
    P7_UART_BASE(1),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_1,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL1_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf1[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL1_BUFSIZE];
static unsigned char
p7dev_serial_in_buf1[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL1_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial1,
				 parrot5_serial_funs,
				 p7dev_serial_info1,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL1_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf1[0],
				 sizeof(p7dev_serial_out_buf1),
				 &p7dev_serial_in_buf1[0],
				 sizeof(p7dev_serial_in_buf1));
#else
static SERIAL_CHANNEL(p7dev_channel_serial1,
		       parrot5_serial_funs,
		       p7dev_serial_info1,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL1_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io1,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL1_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial1 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL1

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL2

static parrot5_serial_info p7dev_serial_info2 = {
    P7_UART_BASE(2),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_2,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL2_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf2[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL2_BUFSIZE];
static unsigned char
p7dev_serial_in_buf2[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL2_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial2,
				 parrot5_serial_funs,
				 p7dev_serial_info2,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL2_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf2[0],
				 sizeof(p7dev_serial_out_buf2),
				 &p7dev_serial_in_buf2[0],
				 sizeof(p7dev_serial_in_buf2));
#else
static SERIAL_CHANNEL(p7dev_channel_serial2,
		       parrot5_serial_funs,
		       p7dev_serial_info2,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL2_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io2,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL2_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial2 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL2

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL3

static parrot5_serial_info p7dev_serial_info3 = {
    P7_UART_BASE(3),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_3,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL3_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf3[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL3_BUFSIZE];
static unsigned char
p7dev_serial_in_buf3[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL3_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial3,
				 parrot5_serial_funs,
				 p7dev_serial_info3,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL3_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf3[0],
				 sizeof(p7dev_serial_out_buf3),
				 &p7dev_serial_in_buf3[0],
				 sizeof(p7dev_serial_in_buf3));
#else
static SERIAL_CHANNEL(p7dev_channel_serial3,
		       parrot5_serial_funs,
		       p7dev_serial_info3,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL3_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io3,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL3_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial3 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL3

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL4

static parrot5_serial_info p7dev_serial_info4 = {
    P7_UART_BASE(4),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_4,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL4_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf4[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL4_BUFSIZE];
static unsigned char
p7dev_serial_in_buf4[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL4_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial4,
				 parrot5_serial_funs,
				 p7dev_serial_info4,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL4_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf4[0],
				 sizeof(p7dev_serial_out_buf4),
				 &p7dev_serial_in_buf4[0],
				 sizeof(p7dev_serial_in_buf4));
#else
static SERIAL_CHANNEL(p7dev_channel_serial4,
		       parrot5_serial_funs,
		       p7dev_serial_info4,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL4_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io4,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL4_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial4 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL4

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL5

static parrot5_serial_info p7dev_serial_info5 = {
    P7_UART_BASE(5),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_5,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL5_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf5[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL5_BUFSIZE];
static unsigned char
p7dev_serial_in_buf5[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL5_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial5,
				 parrot5_serial_funs,
				 p7dev_serial_info5,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL5_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf5[0],
				 sizeof(p7dev_serial_out_buf5),
				 &p7dev_serial_in_buf5[0],
				 sizeof(p7dev_serial_in_buf5));
#else
static SERIAL_CHANNEL(p7dev_channel_serial5,
		       parrot5_serial_funs,
		       p7dev_serial_info5,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL5_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io5,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL5_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial5 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL5

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL6

static parrot5_serial_info p7dev_serial_info6 = {
    P7_UART_BASE(6),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_6,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL6_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf6[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL6_BUFSIZE];
static unsigned char
p7dev_serial_in_buf6[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL6_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial6,
				 parrot5_serial_funs,
				 p7dev_serial_info6,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL6_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf6[0],
				 sizeof(p7dev_serial_out_buf6),
				 &p7dev_serial_in_buf6[0],
				 sizeof(p7dev_serial_in_buf6));
#else
static SERIAL_CHANNEL(p7dev_channel_serial6,
		       parrot5_serial_funs,
		       p7dev_serial_info6,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL6_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io6,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL6_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial6 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL6

#ifdef CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL7

static parrot5_serial_info p7dev_serial_info7 = {
    P7_UART_BASE(7),
    /*P6_SYS_CLK_UART0*/0,
    CYGNUM_HAL_INTERRUPT_UART_7,
};

#if CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL7_BUFSIZE > 0
static unsigned char
p7dev_serial_out_buf7[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL7_BUFSIZE];
static unsigned char
p7dev_serial_in_buf7[CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL7_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS(p7dev_channel_serial7,
				 parrot5_serial_funs,
				 p7dev_serial_info7,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL7_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p7dev_serial_out_buf7[0],
				 sizeof(p7dev_serial_out_buf7),
				 &p7dev_serial_in_buf7[0],
				 sizeof(p7dev_serial_in_buf7));
#else
static SERIAL_CHANNEL(p7dev_channel_serial7,
		       parrot5_serial_funs,
		       p7dev_serial_info7,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_CORTEXA_P7_SERIAL7_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p7dev_serial_io7,
             CYGDAT_IO_SERIAL_CORTEXA_P7_SERIAL7_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p7dev_channel_serial7 );
#endif //  CYGPKG_IO_SERIAL_CORTEXA_P7_SERIAL7

//-----------------------------------------------------------------------------
// EOF arm_arm9_p6dev_ser.inl
