#ifndef __ASSEMBLER__
#include <cyg/infra/cyg_type.h>
#include <stddef.h>
#endif

#define CYGMEM_REGION_ram          (0)
// Declare 8 MB of RAM and leave out 878ko for LCD framebuffers
//We will use the same video buffer for the MOGO and KORO
//For MOGO (320 * 240 * 4) * 2
//For KORO (480 * 234 * 4) + (410 * 270 * 4)
#define CYGMEM_REGION_ram_SIZE_T   (0x00800000)
#define CYGMEM_REGION_ram_SIZE     (0x00724A00)
#define CYGMEM_REGION_ram_ATTR     (CYGMEM_REGION_ATTR_R|CYGMEM_REGION_ATTR_W)
#define CYGMEM_REGION_ram_PHYS     (0x30000000)
#define CYGMEM_REGION_ram_SHADOW   (CYGMEM_REGION_ram_PHYS)

#define CYGMEM_REGION_sram         (0x40000000)
#define CYGMEM_REGION_sram_SIZE    (0x00001000)
#define CYGMEM_REGION_sram_ATTR    (CYGMEM_REGION_ATTR_R|CYGMEM_REGION_ATTR_W)

#ifndef __ASSEMBLER__
extern char CYG_LABEL_NAME (__heap1) [];
#endif

#define CYGMEM_SECTION_heap1      (CYG_LABEL_NAME (__heap1))
#define CYGMEM_SECTION_heap1_SIZE (CYGMEM_REGION_ram_SIZE-(size_t)CYG_LABEL_NAME(__heap1))

// Memory protection stuff
#ifdef CYGPKG_MEMPROT

// eCos heap: we cannot allocate all remaining RAM to heap, because we need
// some for virtual allocation... So we give it a fixed size for now (1 MB)
#undef CYGMEM_SECTION_heap1_SIZE
#define CYGMEM_SECTION_heap1_SIZE  (0x000100000)

// Flash memory
//#define CYGMEM_REGION_flash        (0x34000000)
//#define CYGMEM_REGION_flash_SIZE   (0x04000000)
//#define CYGMEM_REGION_flash_SHADOW (0x08000000)

// Virtual memory space (should be at least 1.5 GB)
#define CYGMEM_DEFAULT_TTB         (CYGMEM_REGION_ram_PHYS + 0x4000)
#define CYGMEM_REGION_virtual      (0x90000000)
#define CYGMEM_REGION_virtual_SIZE (0x70000000)
#endif
