#ifndef CYGONCE_MEMALLOC_DLMALLOCUSER_H
#define CYGONCE_MEMALLOC_DLMALLOCUSER_H
/**
 * ============================================================================
 * @file  dlmallocuser.h
 * @brief C API for user mode dlmalloc
 *
 * Memory protection memory allocation.
 *
 * Copyright (C) 2004,2005 Parrot S.A.
 *
 * @author     ivan.djelic@parrot.fr
 * @date       2004-06-28
 * ============================================================================
 */

#include "dlmallocuserd.h"

void cyg_mempool_dlmalloc_create(
    void            *base,              /* base of memory to use for pool */
    cyg_int32       size,               /* size of memory in bytes        */
    cyg_handle_t    *handle,            /* returned handle of memory pool */
    cyg_mempool_dlmalloc *dl,           /* space to put pool structure in */
    int sbrk_enabled,                   /* enable use of sbrk */
    int domain                          /* memory pool domain */
    );

void cyg_mempool_dlmalloc_delete(cyg_handle_t dlpool);

void *cyg_mempool_dlmalloc_try_alloc(
    cyg_handle_t dlpool,
    cyg_int32    size);

void cyg_mempool_dlmalloc_free(cyg_handle_t dlpool, void *p);

void *cyg_mempool_dlmalloc_resize_alloc( cyg_handle_t dlpool,
					 cyg_uint8 *ptr, cyg_int32 size,
					 cyg_int32 *oldsize);

#endif // CYGONCE_MEMALLOC_DLMALLOCUSER_H
