
// Dynamically loaded module test

#include <cyg/kernel/kapi.h>
#include <stdio.h>

#include <math.h>
#include <string.h>
#include <stdlib.h>

#define NB_THREADS        (5)
#define STACK_SIZE        (4096)

cyg_mutex_t cliblock;

static cyg_thread obj[NB_THREADS];
static char stack[NB_THREADS][STACK_SIZE];
static cyg_handle_t handle[NB_THREADS];

int modulelib_foo(int);

void
action(int data, int delay) {

    /* note: printf() must be protected by a
       call to cyg_mutex_lock() */
    cyg_mutex_lock(&cliblock);
    printf( "Module Thread %d: and now a delay of %d clock ticks\n",
            data, delay );
    cyg_mutex_unlock(&cliblock);

    modulelib_foo((int)data);

    cyg_thread_delay(delay);
}

static void
module_thread(cyg_addrword_t data) {
    int delay;

    cyg_mutex_lock(&cliblock);
    printf("Beginning execution; thread data is %d\n", (int)data );
    cyg_mutex_unlock(&cliblock);

    cyg_thread_delay(100);

    for (;;) {
        delay = 100 + (rand() % 50);
        action((int)data, delay);
    }
}

void
module_entry(cyg_addrword_t data) __attribute__((visibility("default")));
void
module_entry(cyg_addrword_t data) {
    int i;

    printf("Entering Module thread\n");

    cyg_mutex_init(&cliblock);

    for ( i = 0; i < NB_THREADS; i++ ) {
        printf( "Creating module thread %d...\n", i );

        cyg_thread_create( 4, module_thread, (cyg_addrword_t)i,
                           "Module Thread", (void *) stack[i], STACK_SIZE,
                           &handle[i], &obj[i]);
        cyg_thread_resume(handle[i]);
    }
}
